﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using System.IO;
using System.Reflection;

public sealed class LogFile
{
    static readonly LogFile instance = new LogFile();
    static LogFile(){}
    public static LogFile Instance
    {
        get
        {
            return instance;
        }
    }

    private List<FunctionEntry> FuncList;
//    private long Start;
    public void Init()
    {
        FuncList = new List<FunctionEntry>();
        FuncList.Add(new FunctionEntry("Update"));  // 0
        FuncList.Add(new FunctionEntry("Draw"));    // 1
        FuncList.Add(new FunctionEntry("Render Fieldmap"));    // 2
        FuncList.Add(new FunctionEntry("Render Minimap"));  // 3
        FuncList.Add(new FunctionEntry("Render Infoscreen"));   // 4
        FuncList.Add(new FunctionEntry("GetUniverse"));    // 5
        FuncList.Add(new FunctionEntry("Input"));    // 6
        FuncList.Add(new FunctionEntry("Starfield"));    // 7
        FuncList.Add(new FunctionEntry("Elementezeichnen"));    // 8
        FuncList.Add(new FunctionEntry("CollisionCheck"));    // 9
        FuncList.Add(new FunctionEntry("MoveFieldElements"));    // 10
        FuncList.Add(new FunctionEntry("ControllAIPlayers"));    // 11
        FuncList.Add(new FunctionEntry("UniverseMakeCopy"));    // 12
//        Start = DateTime.Now.Ticks;
    }
    ~LogFile()
    {
        StreamWriter logfile;
        logfile = File.CreateText(Path.GetDirectoryName(Assembly.GetEntryAssembly().Location) + "\\TimeLog.log"); // Datei öffnen
        logfile.Write("index    calls   zerodurationcalls   funcname    meanduration    minduration     maxduration\n");
        for (int i = 0; i < FuncList.Count; i++)
        {
            logfile.Write(String.Format("{0}    {1}     {2}     {3}     {4}     {5}     {6}\n", i, FuncList[i].calls, FuncList[i].zerodurationcall, FuncList[i].name, (float)(FuncList[i].duration) / (float)FuncList[i].calls, FuncList[i].min, FuncList[i].max));
        }
        logfile.Close();
    }

    public void StartFunction(int funcindex)
    {
        FuncList[funcindex].starttime = DateTime.Now.Ticks;
        ++FuncList[funcindex].calls;
    }
    public void EndFunction(int funcindex)
    {
        long duration = DateTime.Now.Ticks - FuncList[funcindex].starttime;
        if (duration > 0)
        {
            FuncList[funcindex].duration += duration; // die zeiten aufaddieren
            if (duration < FuncList[funcindex].min)
            {
                FuncList[funcindex].min = duration;
            }
            if (duration > FuncList[funcindex].max)
            {
                FuncList[funcindex].max = duration;
            }
        }
        else
            ++FuncList[funcindex].zerodurationcall;
    }

    private class FunctionEntry
    {// lokale Klasse zur Verwaltung der gestarteten funktionen
        public String name;
        public long starttime;
        public long duration;
        public long calls;
        public long min;
        public long max;
        public long zerodurationcall;

        public FunctionEntry(String funcname) { name = funcname; duration = calls = max = zerodurationcall = 0; min = 100000000; }
    }
}

